        #include <cmrc/cmrc.hpp>
#include <map>
#include <utility>

namespace cmrc {
namespace awconsolidated_resources {

namespace res_chars {
// These are the files which are available in this resource library
// Pointers to /builddir/build/BUILD/airwin2rack/res/FiraMono-Regular.ttf
extern const char* const f_8f2d_res_FiraMono_Regular_ttf_begin;
extern const char* const f_8f2d_res_FiraMono_Regular_ttf_end;
// Pointers to /builddir/build/BUILD/airwin2rack/res/PlusJakartaSans-Medium.ttf
extern const char* const f_2ba8_res_PlusJakartaSans_Medium_ttf_begin;
extern const char* const f_2ba8_res_PlusJakartaSans_Medium_ttf_end;
// Pointers to /builddir/build/BUILD/airwin2rack/res/PlusJakartaSans-SemiBold.ttf
extern const char* const f_7b16_res_PlusJakartaSans_SemiBold_ttf_begin;
extern const char* const f_7b16_res_PlusJakartaSans_SemiBold_ttf_end;
// Pointers to /builddir/build/BUILD/airwin2rack/res/clipper.svg
extern const char* const f_b9f4_res_clipper_svg_begin;
extern const char* const f_b9f4_res_clipper_svg_end;
}

namespace {

const cmrc::detail::index_type&
get_root_index() {
    static cmrc::detail::directory root_directory_;
    static cmrc::detail::file_or_directory root_directory_fod{root_directory_};
    static cmrc::detail::index_type root_index;
    root_index.emplace("", &root_directory_fod);
    struct dir_inl {
        class cmrc::detail::directory& directory;
    };
    dir_inl root_directory_dir{root_directory_};
    (void)root_directory_dir;
    static auto f_9b20_res_dir = root_directory_dir.directory.add_subdir("res");
    root_index.emplace("res", &f_9b20_res_dir.index_entry);
    root_index.emplace(
        "res/FiraMono-Regular.ttf",
        f_9b20_res_dir.directory.add_file(
            "FiraMono-Regular.ttf",
            res_chars::f_8f2d_res_FiraMono_Regular_ttf_begin,
            res_chars::f_8f2d_res_FiraMono_Regular_ttf_end
        )
    );
    root_index.emplace(
        "res/PlusJakartaSans-Medium.ttf",
        f_9b20_res_dir.directory.add_file(
            "PlusJakartaSans-Medium.ttf",
            res_chars::f_2ba8_res_PlusJakartaSans_Medium_ttf_begin,
            res_chars::f_2ba8_res_PlusJakartaSans_Medium_ttf_end
        )
    );
    root_index.emplace(
        "res/PlusJakartaSans-SemiBold.ttf",
        f_9b20_res_dir.directory.add_file(
            "PlusJakartaSans-SemiBold.ttf",
            res_chars::f_7b16_res_PlusJakartaSans_SemiBold_ttf_begin,
            res_chars::f_7b16_res_PlusJakartaSans_SemiBold_ttf_end
        )
    );
    root_index.emplace(
        "res/clipper.svg",
        f_9b20_res_dir.directory.add_file(
            "clipper.svg",
            res_chars::f_b9f4_res_clipper_svg_begin,
            res_chars::f_b9f4_res_clipper_svg_end
        )
    );
    return root_index;
}

}

cmrc::embedded_filesystem get_filesystem() {
    static auto& index = get_root_index();
    return cmrc::embedded_filesystem{index};
}

} // awconsolidated_resources
} // cmrc
    